/* listaller-0.5.vapi generated by valac 0.16.0, do not modify. */

namespace Listaller {
	namespace Dep {
		[CCode (cheader_filename = "listaller.h")]
		public enum ComponentType {
			SHARED_LIB,
			BINARY,
			PYTHON,
			PYTHON_2,
			FILE,
			UNKNOWN
		}
	}
	namespace IPK {
		[CCode (cheader_filename = "listaller.h")]
		public abstract class Control : GLib.Object {
			protected Listaller.AppItem? appItem;
			public Listaller.AppItem get_application ();
			public string get_architectures ();
			public Gee.ArrayList<Listaller.IPK.Dependency> get_dependencies ();
			public string get_ipk_version ();
			public string get_replaces ();
			protected bool open_depinfo (string depMetaFile);
			protected bool open_doap (string data);
			protected bool open_doap_file (string fname);
			protected bool open_packsetting (string pksFName);
			public void set_architectures (string archs);
			public void set_dependencies (Gee.ArrayList<Listaller.IPK.Dependency> list);
			public void set_ipk_version (string ipkV);
			public void set_license_text (string txt);
			public bool set_license_text_from_file (string fname);
			public void set_replaces (string repList);
		}
		[CCode (cheader_filename = "listaller.h")]
		public class ControlDir : Listaller.IPK.Control {
			public ControlDir ();
			public bool auto_dependency_search ();
			public string? get_doap_data ();
			public string get_files_rootdir ();
			public bool open_dir (string dir) throws Listaller.IPK.ControlDataError;
			public bool save_control ();
		}
		[CCode (cheader_filename = "listaller.h")]
		public class Dependency : GLib.Object {
			public void add_component (string cname, Listaller.Dep.ComponentType tp);
			public void add_component_list (Listaller.Dep.ComponentType ty, string list);
			public static string component_get_name (string cidname);
			public static Listaller.Dep.ComponentType component_get_type (string cidname);
			public string get_install_dir_for_setting (Listaller.Settings conf);
			public Gee.HashSet<string> get_installdata ();
			public string get_installdata_as_string ();
			public bool has_component (string cname, Listaller.Dep.ComponentType tp);
			public bool has_components ();
			public bool has_feed ();
			public bool has_installdata ();
			public void regenerate_depid ();
			public string architecture { get; set; }
			public string author { get; set; }
			public string description { get; set; }
			public string environment { get; set; }
			public string feed_url { get; set; }
			public string full_name { get; set; }
			public string homepage { get; set; }
			public string idname { get; set; }
			public int64 install_time { get; set; }
			public bool is_standardlib { get; set; }
			public Gee.HashSet<string> raw_complist { get; }
			public bool satisfied { get; set; }
			public string summary { get; set; }
			public string version { get; set; }
		}
		[CCode (cheader_filename = "listaller.h")]
		public class PackControl : Listaller.IPK.Control {
			public PackControl ();
			public bool create_new (string? newDoapData, string ipkV);
			[CCode (array_length = false, array_null_terminated = true)]
			public string[] get_files ();
			public bool open_control (string fPackSetting, string fDoap, string fDeps);
			public bool save_to_dir (string dirPath);
		}
		[CCode (cheader_filename = "listaller.h")]
		public class PackSecurity : GLib.Object {
			public Listaller.SecurityLevel get_level ();
			public Listaller.SignStatus signature_status { get; set; }
			public Listaller.SignTrust signature_trustlevel { get; set; }
		}
		[CCode (cheader_filename = "listaller.h")]
		public errordomain ControlDataError {
			NO_DOAP,
			DOAP_INVALID,
			DEPLIST_INVALID,
			INTERNAL,
			UNKNOWN
		}
	}
	namespace Utils {
		[CCode (cheader_filename = "listaller.h")]
		public static string li_build_filename (string first_element, ...);
	}
	[CCode (cheader_filename = "listaller.h")]
	public class AppItem : GLib.Object {
		public AppItem (string afullname, string aversion, string desktop_filename = "");
		public AppItem.blank ();
		public int compare_version_with (string bversion);
		public void fast_check ();
		public AppItem.from_desktopfile (string desktop_filename);
		public AppItem.from_id (string application_id);
		public string get_raw_cmd (bool subst_cmd = false);
		public void set_license_from_doap_name (string? name);
		public void set_license_name (string lName);
		public void set_license_text (string lText);
		public void set_origin_from_string (string? s);
		public string to_string ();
		public void update_with_appid (bool fast = false);
		public void update_with_desktop_file ();
		public static bool validate_appid (string application_id);
		public string appid { get; }
		public string author { get; set; }
		public string categories { get; set; }
		public string dependencies { get; set; }
		public string description { get; set; }
		public string desktop_file { get; set; }
		public string full_name { get; set; }
		public string icon_name { get; set; }
		public string idname { get; set; }
		public int64 install_time { get; set; }
		public Listaller.AppLicense license { get; set; }
		public Listaller.AppOrigin origin { get; set; }
		public string publisher { get; set; }
		public string replaces { get; set; }
		public bool shared { get; set; }
		public int size_installed { get; set; }
		public string summary { get; set; }
		public string version { get; set; }
		public string website { get; set; }
	}
	[CCode (cheader_filename = "listaller.h")]
	public class ErrorItem : GLib.Object {
		public ErrorItem (Listaller.ErrorEnum type);
		public string to_string ();
		public string details { get; set; }
		public Listaller.ErrorEnum error { get; set; }
	}
	[CCode (cheader_filename = "listaller.h")]
	public class Manager : Listaller.MsgObject {
		public Manager (Listaller.Settings? settings);
		public bool find_applications (Listaller.AppSource filter, out Gee.ArrayList<Listaller.AppItem> appList = null);
		public bool find_applications_by_values (Listaller.AppSource filter, [CCode (array_length = false, array_null_terminated = true)] string[] values, out Gee.ArrayList<Listaller.AppItem> appList = null);
		public string get_app_ld_environment (Listaller.AppItem app);
		public Listaller.AppItem? get_application_by_idname (string idname);
		public string? get_application_filelist_as_string (Listaller.AppItem app);
		public Gee.ArrayList<Listaller.AppItem>? get_applications_by_fullname (string full_name);
		public bool refresh_appitem (ref Listaller.AppItem item);
		public bool remove_application (Listaller.AppItem app);
		public bool scan_applications ();
		public Listaller.Settings settings { get; set; }
		public signal void application (Listaller.AppItem appid);
		public signal void status_changed (Listaller.StatusItem status);
	}
	[CCode (cheader_filename = "listaller.h")]
	public class MessageItem : GLib.Object {
		public MessageItem (Listaller.MessageEnum type);
		public string to_string ();
		public string details { get; set; }
		public Listaller.MessageEnum mtype { get; set; }
	}
	[CCode (cheader_filename = "listaller.h")]
	public abstract class MsgObject : GLib.Object {
		public MsgObject ();
		protected void connect_with_object (Listaller.MsgObject other, Listaller.ObjConnectFlags flags);
		protected void connect_with_object_all (Listaller.MsgObject other);
		protected void set_error_hint_str (string str);
		public signal void error_code (Listaller.ErrorItem error);
		public signal void message (Listaller.MessageItem message);
		public signal void progress_changed (int progress, int sub_progress);
	}
	[CCode (cheader_filename = "listaller.h")]
	public class Settings : GLib.Object {
		public Settings (bool root = false);
		public string appdata_dir ();
		public string appregister_dir ();
		public string conf_dir ();
		public string database_file ();
		public string depdata_dir ();
		public string desktop_dir ();
		public string get_unique_install_tmp_dir ();
		public string get_unique_tmp_dir (string prefix = "listaller");
		public string icon_base_dir ();
		public string icon_size_dir (int size = 0);
		[CCode (array_length = false, array_null_terminated = true)]
		public string[] library_paths ();
		public void @lock ();
		public string tmp_dir ();
		public void unlock ();
		public bool locked { get; }
		public bool sumode { get; set; }
		public bool testmode { get; set; }
	}
	[CCode (cheader_filename = "listaller.h")]
	public class Setup : Listaller.MsgObject {
		public Setup (string ipkfilename, Listaller.Settings? settings);
		public Listaller.AppItem? get_current_application ();
		public string? get_replaced_native_packs ();
		public Listaller.IPK.PackSecurity get_security_info ();
		public bool initialize ();
		public void kill_installation_process ();
		public bool run_installation ();
		public Listaller.IPK.Control? control { get; }
		public Listaller.Settings settings { get; }
		public signal void status_changed (Listaller.StatusItem status);
	}
	[CCode (cheader_filename = "listaller.h")]
	public class StatusItem : GLib.Object {
		public StatusItem (Listaller.StatusEnum type);
		public string info { get; set; }
		public Listaller.StatusEnum status { get; set; }
	}
	[CCode (cheader_filename = "listaller.h")]
	public struct AppLicense {
		public string name;
		public string text;
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum AppOrigin {
		IPK,
		NATIVE,
		UNKNOWN,
		INVALID;
		public string to_string ();
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum AppSource {
		ALL,
		EXTERN,
		NATIVEPKG,
		UNKNOWN
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum DatabaseStatus {
		OPENED,
		LOCKED,
		UNLOCKED,
		SUCCESS,
		FAILURE,
		CLOSED;
		public string to_string ();
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum ErrorEnum {
		UNKNOWN,
		IPK_LOADING_FAILED,
		UNPACKING_FAILED,
		SETUP_NOT_INITIALIZED,
		IPK_INCOMPLETE,
		IPK_DAMAGED,
		FILE_EXISTS,
		HASH_MISSMATCH,
		FILE_INSTALL_FAILED,
		COPY_ERROR,
		DATABASE_LOCKED,
		DATABASE_FAILURE,
		DB_OPEN_FAILED,
		ALREADY_INSTALLED,
		REMOVAL_FAILED,
		INSTALLATION_FAILED,
		WRONG_ARCHITECTURE,
		DEPENDENCY_MISSING,
		DEPENDENCY_INSTALL_FAILED,
		NATIVE_TRANSACTION_FAILED,
		NETWORK_ERROR,
		INTERNAL,
		INVALID;
		public string to_string ();
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum MessageEnum {
		UNKNOWN,
		INFO,
		WARNING,
		CRITICAL;
		public string to_string ();
	}
	[CCode (cheader_filename = "listaller.h")]
	protected enum ObjConnectFlags {
		NONE,
		PROGRESS_TO_SUBPROGRESS,
		IGNORE_PROGRESS,
		IGNORE_ERROR_CODE
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum SecurityLevel {
		UNKNOWN,
		HIGH,
		MEDIUM,
		LOW,
		DANGEROUS;
		public string to_string ();
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum SignStatus {
		UNKNOWN,
		VALID,
		KEY_EXPIRED,
		CERT_REVOKED,
		SIG_EXPIRED,
		BAD,
		NO_PUBKEY;
		public string to_string ();
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum SignTrust {
		UNKNOWN,
		UNDEFINED,
		NEVER,
		MARGINAL,
		FULL,
		ULTIMATE;
		public string to_string ();
	}
	[CCode (cheader_filename = "listaller.h")]
	public enum StatusEnum {
		UNKNOWN,
		ACTION_STARTED,
		RESOLVING_DEPENDENCIES,
		INSTALLING_FILES,
		REGISTERING_APPLICATION,
		INSTALLATION_FINISHED,
		REMOVAL_FINISHED
	}
	[CCode (cheader_filename = "listaller.h")]
	public errordomain DatabaseError {
		ERROR,
		BACKING,
		MEMORY,
		ABORT,
		LIMITS,
		TYPESPEC,
		LOCKED
	}
	[CCode (cheader_filename = "listaller.h")]
	protected errordomain RdfError {
		NO_RESULTS,
		INVALID_PATH,
		INVALID_QUERY
	}
	[CCode (cheader_filename = "listaller.h")]
	public static void add_log_domain (string log_domain);
	[CCode (cheader_filename = "listaller.h")]
	public static string app_item_build_pk_package_id (Listaller.AppItem app);
	[CCode (cheader_filename = "listaller.h")]
	public static int compare_versions (string a, string b);
	[CCode (cheader_filename = "listaller.h")]
	public static string get_full_version_info_str ();
	[CCode (cheader_filename = "listaller.h")]
	public static string get_version_info_str ();
	[CCode (cheader_filename = "listaller.h")]
	public static void set_console_mode (bool enabled);
	[CCode (cheader_filename = "listaller.h")]
	public static void set_verbose_mode (bool enabled);
}
[CCode (cheader_filename = "listaller.h")]
public static void li_enable_translation ();
